#!/usr/bin/perl
# TKSSFF.PL--A Perl/Tk command-line program wrapper
# This Perl/Tk program provides a GUI interface to the Site-Specific
# Flood Frequency Program (SSFF).  The SSFF is written in Fortran-77 and
# requires extensive typing, with little error checking on input fields.
# The GUI provides thus user with a convenient tool to perform multiple
# computational runs.  The three output files of the program are overwritten
# each time.  Currently, it is not possible, from the GUI to spool the output
# files nor save them as another file name.  Furthermore, the help stuff isn't
# functional.  The About works though.
# Program was last modified on March 11, 2003
# The script is operational under Perl5.6 and Tk800.024
use Tk;
use Cwd;
die "tkssff.pl: Should not be run by root because ",
        "of security concerns involving the necessary",
        "but few uses of the 'eval' function.\n"
        if((not $< or not $>) and $^O !~ /MSWin/o);

END {  # Recall than END blocks are executed even on a die or runtime error
   unlink("glsxx1.tmp") if(-e "glsxx1.tmp");
   unlink("glsxx2.tmp") if(-e "glsxx2.tmp");
   map { unlink($_) if (-e $_) } @runfiles;                                            
}

my @message1 = ("  VIEW FULL OUTPUT  ",
                     "REMOVE FULL OUTPUT",);
my @message2 = (" VIEW SUMMARY ",
                     "REMOVE SUMMARY");
my @message3 = (" VIEW STATIONS ",
                     "REMOVE STATIONS");
             
my $bviewtext1 = $message1[0];
my $bviewtext2 = $message2[0];
my $bviewtext3 = $message3[0];
my $status = 'All go';
my @runfiles = qw(glsfullxx.tmp glssumxx.out glsstaxx.out);
my $stfont = "-Adobe-Courier-Bold-R-Normal--*-120-*-*-*-*-*-*";
my $entcolor = 'grey97';
my $f77exec = ($^O =~ /MSWin/o) ? 'txfreq2003.exe' :
              ($^O =~ /linux/o) ? 'txfreq2003.linux' : 'txfreq2003.sun';
          # FORTRAN executable
        
my $MW = MainWindow->new(-title => "tkssff.PL");



MENUS: {  # Build the menu on the mainwindow
   $fmenu = $MW->Frame()->pack(-fill => 'x');
   $menub = $fmenu->Menubutton(-text       => 'Help',
                               -justify    => 'right',
                               -foreground => 'dark slate grey',
                               -relief     => 'groove')
                    ->pack(-anchor => 'ne',
                           -side   => 'top');
   $menub->command(-label            => 'About',
                   -foreground       => 'SeaGreen',
                   -activeforeground => 'SeaGreen',
                   -command => \&About_Window);                        
   $menub->command(-label => 'with Program', -command => sub { return; } );
   $menub->command(-label => 'with Results', -command => sub { return; } );
   
}

HEADER: {  # Put a long title in the mainwindow
   $ltop = $MW->Label(-text => "\n   TEXAS SITE-SPECIFIC FLOOD FREQUENCY PROGRAM   \n",
                      -anchor      => 'n',
                      -relief      => 'groove',
                      -height      => 3,
                      -borderwidth => 3)->pack();
}


LOC_AND_CHAR: {  # Note the extensive use of frames to get the packing right
   $fsite = $MW->Frame()->pack(-fill => 'x');
   $fsite->Label(-text  => '  Site Name')
           ->pack(-side => 'left');
   $fsite->Entry(-width        => 30,
                 -textvariable => \$siteid,
                 -background   => $entcolor)
           ->pack(-side => 'left');

   $flat = $MW->Frame()
              ->pack(-fill => 'x'); 
   $flat->Label(-text  => '  Latitude')
        ->pack(-side => 'left');       
   $flat->Entry(-width        => 3,
                -textvariable => \$latd,
                -background   => $entcolor)
         ->pack(-side => 'left');
   $flat->Label(-text  => 'DD  ')
        ->pack(-side => 'left');
   $flat->Entry(-width        => 3,
                -textvariable => \$latm,
                -background   => $entcolor )
        ->pack(-side => 'left');
   $flat->Label(-text  => 'MM')
        ->pack(-side => 'left');
   $flat->Entry(-width        => 3,
                -textvariable => \$lats,
                -background   => $entcolor)
        ->pack(-side => 'left');
   $flat->Label(-text  => 'SS')
        ->pack(-side => 'left');
   
   $flon = $MW->Frame()->pack(-fill => 'x'); 
   $flon->Label(-text => 'Longitude')
         ->pack(-side => 'left');        
   $flon->Entry(-width        => 4,
                -textvariable => \$lond,
                -background   => $entcolor)
        ->pack(-side => 'left');
   $flon->Label(-text  => 'DD')
          ->pack(-side => 'left');
   $flon->Entry(-width        => 3,
                -textvariable => \$lonm,
                -background   => $entcolor)
        ->pack(-side => 'left');
   $flon->Label(-text  => 'MM')
        ->pack(-side => 'left');
   $flon->Entry(-width => 3,
                -textvariable => \$lons,
                -background => $entcolor)
        ->pack(-side => 'left');
   $flon->Label(-text  => 'SS')
        ->pack(-side => 'left');
   $flon->Label(-text  => "\n")
        ->pack(-side => 'left');

   $fchar1 = $MW->Frame()->pack(-fill => 'x');
   $fchar1->Label(-text  => "BASIN CHARACTERISTICS")->pack();
   $fchar1->Label(-text  => 'Contributing Drainage Area')
          ->pack(-side => 'left');
   $fchar1->Entry(-width => 9,
                  -textvariable => \$area,
                  -background => $entcolor)
          ->pack(-side => 'left');
   $fchar1->Label(-text  => 'square miles')
          ->pack(-side => 'left');

   $fchar2 = $MW->Frame()->pack(-fill => 'x');
   $fchar2->Label(-text  => '          Basin Shape Factor')
          ->pack(-side => 'left');
   $fchar2->Entry(-width => 9,
                  -textvariable => \$shape,
                  -background => $entcolor)
          ->pack(-side => 'left');
   $fchar2->Label(-text  => 'feet per mile')
          ->pack(-side => 'left');

   $fchar3 = $MW->Frame()->pack(-fill => 'x');
   $fchar3->Label(-text  => '                   Stream Slope')
            ->pack(-side => 'left');
   $fchar3->Entry(-width        => 9,
                  -textvariable => \$slope,
                  -background => $entcolor )
            ->pack(-side => 'left');
   $fchar3->Label(-text  => 'dimensionless')
            ->pack(-side => 'left');
}

CONFIG_ANALYSIS: {
   $fstat = $MW->Frame(-width => 50)->pack(-fill => 'x');
   $fstat->Label(-text => "\nCONFIGURE THE ANALYSIS")->pack();
   $fstat->Label(-text => '  Number of stations to \'pool\' together')
           ->pack(-side => 'left');
   $fstat->Entry(-width        => 2,
                 -textvariable => \$nostations,
                 -background => $entcolor )
           ->pack(-side => 'left');
   $fstat->Label(-text => ' 20 <=> 50 ')->pack(-side => 'left');


   $f_cb_1 = $MW->Frame()->pack(-fill => 'x');  
   $cb_1 = $f_cb_1->Checkbutton(-text => 'Only use Drainage Area in the analysis',
                                -onvalue  => 'Y',
                                -offvalue => 'N',
                                -variable => \$vartype)
                    ->pack();
                         
 
   $fchoice = $MW->Frame(-relief      => 'sunken',
                      -borderwidth => 1)
                   ->pack( -expand => 1,
                           -side   => 'top');
   $fchoice->Radiobutton(-text     => 'Proximity (Area bounded by 1.5 log-cycles)',
                         -variable => \$selection,
                         -value    => '1',
                         -anchor   => 'nw')->pack(-side   => 'top', 
                                                  -anchor => 'w')->select;
                                                  
   $fchoice->Radiobutton(-text     => 'Similarity (Area, Shape, Slope, Distance)',
                         -variable => \$selection,
                         -value    => '2',
                         -anchor   => 'w')->pack(-side   => 'top',
                                                 -anchor => 'w');
   $fchoice->Radiobutton(-text     => 'Similarity (Area and Distance)',
                         -variable => \$selection,
                         -value    => '3',
                         -anchor   => 's')
             ->pack(-side   => 'top',
                    -anchor => 'w' );                        
}

BUTTONS: {
   $bgo = $MW->Button(-text             => 'ANALYZE',
                      -command          => \&Run_Gls,
                      -padx             => 10,
                      -foreground       => 'red1',
                      -activeforeground => 'red1')
               ->pack(-side => 'top',
                      -padx => 10,
                      -pady => 4);
                        
   $fbutton = $MW->Frame()->pack(-fill => 'x');
   $bview1 = $fbutton->Button(-textvariable => \$bviewtext1,
                              -command      => \&View_Full_Output,
                              -padx         => 10 )
                       ->pack(-side   => 'top',
                              -anchor => 'w', 
                              -padx   => 10 ); 
   $bview2 = $fbutton->Button(-textvariable => \$bviewtext2,
                              -command      => \&View_Sum_Output,
                              -padx         => 10 )
                       ->pack(-side   => 'top',
                              -anchor => 'w', 
                              -padx   => 10 );
   $bview3 = $fbutton->Button(-textvariable => \$bviewtext3,
                              -command      => \&View_Stat_Output,
                              -padx         => 10 )
                       ->pack(-side   => 'top',
                              -anchor => 'w', 
                              -padx   => 10 );                                              
   $bexit = $fbutton->Button(-text        => 'EXIT',
                             -command     => sub { exit; },
                             -padx        => 10,
                             -relief      => 'ridge',
                             -borderwidth => 3  )
                      ->pack(-side => 'right',
                             -padx => 10,
                             -padx => 2 );
}

STATUS_BAR: {
   $statbar = $MW->Label(-textvariable => \$status,
                         -borderwidth  => 2,
                         -foreground   => 'dark slate grey',
                         -background   => 'grey',
                         -anchor       => 'w',
                         -relief       => 'groove',
                         -wraplength   => '50c' )
                 ->pack(-fill => 'x',
                        -side => 'bottom');
}

$MW->resizable(0,0);  # disable resizing of mainwindow
MainLoop();

# *****************
# ** SUBROUTINES **
# *****************

sub Run_Gls {  # CALLS THE EXTERNAL FORTRAN PROGRAM
  $MW->configure(-cursor => 'watch');
  $MW->update();
  
  $Update_Status_Bar_and_Arrow = sub { $status = $_[0];
                           $statbar->configure(-textvariable => \$status);
                           $MW->configure(-cursor => 'top_left_arrow');
                           $MW->update();
                         }; # Anon sub to handle cleanup on an error return
                         
  $Update_Status_Bar = sub { $status = $_[0];
                             $statbar->configure(-textvariable => \$status);
                             $statbar->update();
                           };
                         
  CHECKING_ENTRY_FIELDS: {  # Validate the entry fields first as best we can
    foreach ($latd, $latm, $lats, $lond, $lonm,
             $lons, $area, $shape, $slope, $nostations) {
        $_ =~ s/^\s+//;  $_ =~ s/\s+$//; # remove leading and trailing w_space     
        if($_ !~ /[0-9.]/) {
           &$Update_Status_Bar_and_Arrow("Nonnumeric input in one of the fields");
           return;
        }
    }
    if($nostations < 20 or $nostations > 50) {
        &$Update_Status_Bar_and_Arrow("Number of stations outside range allowable");
        return;
    }
    foreach ($latm, $lats, $lonm, $lons) {
        if($_ < 0 or $_ > 60) {
            &$Update_Status_Bar_and_Arrow('Minutes or Seconds must be between 0 and 60');
            return;
        }
    }
    if($latd < 25 or $latd > 37) {
            &$Update_Status_Bar_and_Arrow('Latitude is outside approximate limits of Texas');
            return;           
    }
    if($lond < 93 or $lond > 107) {
            &$Update_Status_Bar_and_Arrow('Longitude is outside approximate limits of Texas');
            return;           
    }
  }
  
  CALL_IT: { # Build input control file, use it, update status, and clean up     
    open(OUTFH, "> glsxx2.tmp") or die "$!\n";  # check file availablity
    close(OUTFH);
    open(OUTFH, "> glsxx1.tmp") or die "$!\n";
        print OUTFH "3\n";
        print OUTFH "$runfiles[0]\n";
        print OUTFH "$runfiles[1]\n";
        print OUTFH "$runfiles[2]\n";
        print OUTFH "e\n","$siteid\n";
        print OUTFH "$latd $latm $lats\n";
        print OUTFH "$lond $lonm $lons\n";
        print OUTFH "$area $shape $slope\n";
        print OUTFH "$nostations\n";
        print OUTFH "$vartype\n";
        print OUTFH "$selection\n";
        print OUTFH "go\n";
    close(OUTFH);

    &$Update_Status_Bar('Spawning the FORTRAN code');
    system("$f77exec < glsxx1.tmp > glsxx2.tmp"); # call Fortran program
    &$Update_Status_Bar('The FORTRAN child has returned');
    sleep 1;
  
    unlink("glsxx1.tmp") if(-e "glsxx1.tmp"); # clean up temp files
    unlink("glsxx2.tmp") if(-e "glsxx2.tmp");
  }
  &$Update_Status_Bar_and_Arrow('All go');
  return;
}


sub About_Window { # The About information under MainWindow-Help(Menu)
  my $twa = $MW->Toplevel(-title     => "ABOUT tkssff",
                          -takefocus => 0);
  $twa->resizable(0,0);  # disable resizing of window                         
  my $text = $twa->Text(-spacing1   => 2,
                        -background => 'mint cream',
                        -height     => 18,
                        -width      => 65)->pack;
  $text->tagConfigure('boldbig', -justify => 'center', -font =>
                      "-Adobe-Helvetica-Bold-R-Normal--*-180-*-*-*-*-*-*");
  $text->tagConfigure('bold',    -justify => 'center', -font =>
                      "-Adobe-Helvetica-Bold-R-Normal--*-160-*-*-*-*-*-*");
  my $about1 = <<ABOUT1;
      
               TKSSFF.PL
               A Perl/Tk GUI wrapper for
               SITE-SPECIFIC FLOOD FREQUENCY PROGRAM
               A command-line only program written
               in Fortran-77
                  
ABOUT1
  $about1 =~ s/^\s+//gm;  # strip leading whitespace from Here Doc
  $text->insert('end', "\n$about1\n", 'boldbig');
  my $about2 = <<ABOUT2;
      
               by William H. Asquith
               U.S. Geological Survey
               Austin, Texas, 78754
               report bugs to wasquith\@usgs.gov
ABOUT2
  $about2 =~ s/^\s+//gm; # strip leading whitespace from Here Doc
  $text->insert('end', "$about2", 'bold');
  $text->configure(-state => 'disabled');
  my $b = $twa->Button(-text        => 'CLOSE',
                       -command     =>
                         sub { $twa->destroy() if Tk::Exists($twa);
                             },
                       -padx        => 10,
                       -relief      => 'ridge',
                       -borderwidth => 3  )
              ->pack(-side => 'bottom',
                     -padx => 10,
                     -padx => 2 );
}

sub View_Full_Output {
   if(not -e $runfiles[0]) {
      $status = 'Analysis has not been performed--hit ANALYSIS first';
      $statbar->configure(-textvariable => \$status);
      $statbar->update();
      sleep 1;
      $status = 'All go';
      $statbar->configure(-textvariable => \$status);
      return;
   }
   if($bviewtext1 eq $message1[0]) {
      $bviewtext1 = $message1[1]; 
      $bview1->configure(-textvariable => \$bviewtext1);
      $tw1=$MW->Toplevel(-title     => "FULL OUTPUT FILE",
                         -takefocus => 0);
      $mbtw1 = $tw1->Menubutton(-text       => 'File',
                                -justify    => 'left',
                                -foreground => 'dark slate grey',
                                -relief     => 'groove')
                   ->pack(-anchor => 'nw', -side => 'top');
      $mbtw1->command(-label   => 'Save As',
                      -command => sub { &Save_Output_Files($tw1, $text1); } );
      $tw1->resizable(0,0);  # disable resizing of window
      $text1 = $tw1->Scrolled("Text")->pack();
      $text1->configure(-background => 'linen',
                        -wrap       => 'none',
                        -font       => $stfont);
      open(FHIN, "< $runfiles[0]") or
        print "Could not open $runfiles[0]\n", return;
        while(<FHIN>) {
          s/\n\n$/\n/g;
          s/^\n//g;
          $text1->insert('end', $_);
        }
      close(FHIN);
      $text1->configure(-state => "disabled");
   }
   else {
      $tw1->destroy() if Tk::Exists($tw1);
      $bviewtext1 = $message1[0];
   }

   return;
}


sub View_Sum_Output {
   if(not -e $runfiles[1]) {
      $status = 'Analysis has not been performed--hit ANALYSIS first';
      $statbar->configure(-textvariable => \$status);
      $statbar->update();
      sleep 1;
      $status = 'All go';
      $statbar->configure(-textvariable => \$status);
      return;
   }
   if($bviewtext2 eq $message2[0]) {
      $bviewtext2 = $message2[1]; 
      $bview2->configure(-textvariable => \$bviewtext2);
      $tw2=$MW->Toplevel(-title     => "SUMMARY OUTPUT FILE",
                         -takefocus => 0);
      $mbtw2 = $tw2->Menubutton(-text       => 'File',
                                -justify    => 'left',
                                -foreground => 'dark slate grey',
                                -relief     => 'groove')
                   ->pack(-anchor => 'nw', -side => 'top');
      $mbtw2->command(-label   => 'Save As',
                      -command => sub { &Save_Output_Files($tw2, $text2); } );
      $tw2->resizable(0,0);  # disable resizing of window
      $text2 = $tw2->Scrolled("Text")->pack();
      $text2->configure(-background => 'ivory',
                        -wrap => 'none',
                        -font => $stfont);
      open(FHIN, "< $runfiles[1]") or
        print "Could not open $runfiles[1]\n", return;
        while(<FHIN>) {
          s/\n\n$/\n/g;
          s/^\n//g;
          $text2->insert('end', $_);
        }
      close(FHIN);
      $text2->configure(-state => "disabled");
   }
   else {
      $tw2->destroy() if Tk::Exists($tw2);
      $bviewtext2 = $message2[0];
   }
   return;
}


sub View_Stat_Output {
   if(not -e $runfiles[2]) {
      $status = 'Analysis has not been performed--hit ANALYSIS first';
      $statbar->configure(-textvariable => \$status);
      $statbar->update();
      sleep 1;
      $status = 'All go';
      $statbar->configure(-textvariable => \$status);
      return;
   }
   if($bviewtext3 eq $message3[0]) {
      $bviewtext3 = $message3[1]; 
      $bview3->configure(-textvariable => \$bviewtext3);
      $tw3=$MW->Toplevel(-title     => "SELECTED STATIONS",
                         -takefocus => 0);
      $mbtw3 = $tw3->Menubutton(-text       => 'File',
                                -justify    => 'left',
                                -foreground => 'dark slate grey',
                                -relief     => 'groove')
                   ->pack(-anchor => 'nw', -side => 'top');
      $mbtw3->command(-label   => 'Save As',
                      -command => sub { &Save_Output_Files($tw3, $text3); } );
      $tw3->resizable(0,0);  # disable resizing of window
      $text3 = $tw3->Scrolled("Text")->pack();
      $text3->configure(-background => 'moccasin',
                        -wrap       => 'none',
                        -font       => $stfont);
      open(FHIN, "< $runfiles[2]") or
        print "Could not open $runfiles[2]\n", return;
        while(<FHIN>) {
          s/\n\n$/\n/g;
          s/^\n//g;
          $text3->insert('end', $_);
        }
      close(FHIN);
      $text3->configure(-state => "disabled");
   }
   else {
      $tw3->destroy() if Tk::Exists($tw3);
      $bviewtext3 = $message3[0];
   }
   return;
}


sub Save_Output_Files {
   my ($tw, $text) = @_;
   my $dir2save = &cwd;
   $filename = $tw->getSaveFile(-title      => "Save File",
                                -initialdir => $dir2save);
   return if(not defined $filename);
   $text->configure(-state => "normal");
   my $file = $text->get("1.0", 'end');
   $text->configure(-state => "disabled"); 
   open(FH, ">$filename") or die "Save_Output_Files $!\n";
     print FH $file;
   close(FH);
   return 1;
}
